#!/bin/bash
#
# Humbly script to update crypt column with {SHA} passwords
# via re-encoding clear column in a VExim database.
# Needs command-line PHP.
#
# Handle with care!
# kzoli@kzoli.hu 2012-02-16

MYSQLPASS="PASSWORD_HERE"
MYSQL="/usr/bin/mysql --skip-column-names -u vexim --password=$MYSQLPASS -D vexim"

uid_list="$(echo "SELECT user_id from users;" | $MYSQL)"

for user_id in $uid_list
do
    clear=$(echo "SELECT clear FROM users WHERE user_id=$user_id" | $MYSQL)
    crypt=$(php -r "print '{SHA}'.base64_encode(pack('H*',sha1('$clear')));") #"
    echo -ne "$user_id, $crypt "
    echo "UPDATE users SET crypt='$crypt' WHERE user_id=$user_id;" | $MYSQL
    echo "- updated."
done
